//+------------------------------------------------------------------+
//|                                                  HI_LOW_v001.mq4 |
//|                                                              DOC |
//|                                                   DR_GAD@mail.ru |
//+------------------------------------------------------------------+
#property copyright "DOC"
#property link      "DR_GAD@mail.ru"

#property indicator_chart_window
//--- input parameters
extern bool      Ocean_max_min=true;
extern bool      Asian_max_min=true;
extern bool      Europe_max_min=true;
extern bool      USA_max_min=true;

 bool      Day_max_min=true;
extern bool      Week_max_min=false;
extern bool      Month_max_min=false;
extern bool      winter_time=true;
extern int       time_more=0;
#property indicator_buffers 8
#property indicator_color3 Red
#property indicator_color1 Blue
#property indicator_color2 Green
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];



   int t_day=0, t_n=0,p_t, week_max, day_max,mounth_max,winter; 
   int k,z,t,b,l,n,w;
   double max_ok, max_as, max_eu, max_us, min_ok,min_as,min_eu,min_us;
   string Name,Label, Price,Midle;
   string W_Day, M_Day, Session;
   int oc,as,eu,us,oc_c,as_c,eu_c,us_c;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,12,0,1);
   SetIndexArrow(0,241);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0, 0.0);
  
  
   SetIndexStyle(1,12,0,1);
   SetIndexArrow(1, 167);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexEmptyValue(1, 0.0);
  
   SetIndexStyle(3,12,0,1);
    SetIndexArrow(3,217);
   SetIndexBuffer(3, ExtMapBuffer3);
   SetIndexEmptyValue(3, 0.0);
  
   SetIndexStyle(4,12,0,1);
   SetIndexArrow(4, 167);
   SetIndexBuffer(4, ExtMapBuffer4);
   SetIndexEmptyValue(4, 0.0);
   
   SetIndexStyle(5,12,0,1);
   SetIndexArrow(5, 167);
   SetIndexBuffer(5, ExtMapBuffer5);
   SetIndexEmptyValue(5, 0.0);
   
//---- name for DataWindow and indicator subwindow label
   
   
   IndicatorShortName("/  ");
   SetIndexLabel(0, "  ");
   SetIndexLabel(1, "  ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
/* --------------- 
if(TimeDay(Time[i]) != TimeDay(Time[i+1]));//      ?

*/

   int    counted_bars=IndicatorCounted();
   int limit;
  //----     
     if((counted_bars > 0))
         counted_bars--;
     limit = Bars - counted_bars;
  //----  
     for(int i = 1; i < limit; i++)  
 {//  
 
 
       if (winter_time==true)
       winter=1+time_more;
       if (winter_time==false)
       winter=0+time_more;
      
      k=TimeHour(Time[i]);
       z=TimeMinute(Time[i]);
       t=Period();
       if (t==240)
       {
       b=6;
       w=30;
       l=6*Period()*60;
       n=1;
       p_t=1;}
       
       
       if (t==60){b=24;
       w=120;
       l=24*Period()*60;
       n=l;
       p_t=1;}
       
       if (t==30){b=48;
       w=240;
       l=48*Period()*60;
       n=l;
       p_t=2;}
       
       if (t==15){b=96;
       w=480;
       l=96*Period()*60;
       n=l;
       p_t=4;}
       
       if (t==5){b=288;
       l=288*Period()*60;
       w=1440;
       n=l;
       p_t=12;}
       
       if (t==1){b=1440;
       l=1440*6;
       n=l;
       p_t=60;}
      
       if (t>1440){
       Print("  ");
      return(0);
       }
       if (TimeDayOfWeek(Time[i]) == 1){
       n=1.20*t*Period()*60;}
       
        //-------------------
      as=0+winter;
      as_c=9+winter;
      eu=8+winter;
      eu_c=15+winter;
      us=13+winter;
      us_c=22+winter;
      oc=20+winter;
      oc_c=4+winter;
        
      //   
      if (Month()==1){M_Day="";}
      if (Month()==2){M_Day="";}
      if (Month()==3){M_Day="";}
      if (Month()==4){M_Day="";}
      if (Month()==5){M_Day="";}
      if (Month()==6){M_Day="";}
      if (Month()==7){M_Day="";}
      if (Month()==8){M_Day="";}
      if (Month()==9){M_Day="";}
      if (Month()==10){M_Day="";}
      if (Month()==11){M_Day="";}
      if (Month()==12){M_Day="";}
           
      //                          
      if (DayOfWeek()==0){W_Day=" ";}          
      if (DayOfWeek()==1){W_Day=" ";}    
      if (DayOfWeek()==2){ W_Day=" ";}   
      if (DayOfWeek()==3){ W_Day=" "; }         
      if (DayOfWeek()==4){ W_Day=" ";}        
      if (DayOfWeek()==5){ W_Day=" ";}       
      if (DayOfWeek()==6){ W_Day=" ";}       
      
      //  
        
   //----/
    if (Hour()==as && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==as && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=as && Minute()>0) {                                
     Session ="/   ";}  
   
   //-
   
   if (Hour()==oc_c && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==oc_c && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=oc_c && Minute()>0) {                                
     Session ="   ";}  
   
   
   
   
   
   
   //----
    if (Hour()==eu && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==eu && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=eu && Minute()>0) {                                
     Session ="/   ";} 
     
    if (Hour()==as_c && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==as_c && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=as_c && Minute()>0) {                                
     Session ="   ";}  
     
          
     
     
      
   //-----
     if (Hour()==us && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==us && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=us && Minute()>0) {                                
     Session ="/  ";}
     
    if (Hour()==eu_c && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==eu_c && Minute()==0 && Seconds()>1)
     {                                
     Session ="     ";}  
    if (Hour()>=eu_c && Minute()>0) {                                
     Session ="  ";}
  
  
  
  
     
   //-----   
     if (Hour()==oc && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==oc && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=oc && Minute()>0) {                                
     Session ="/   ";}
     
       
     
    if (Hour()==us_c && Minute()==0 && Seconds()<=1) {                                
     PlaySound("Alert.wav");   
     Session ="    ";}    
    if (Hour()==us_c && Minute()==0 && Seconds()>1)
     {                                
     Session ="    ";}  
    if (Hour()>=us_c && Minute()>0) {                                
     Session ="   ";}  
      
      
        
        //-------------------
      Comment ("  -","\n",Day()," ",M_Day," ",W_Day," ",Hour() ," . ",
      Minute()," .", "\n","\n"," " ,Session,"\n");  
      
      
 
  /*   if (TimeDayOfYear(Time[i]) != DayOfYear())
   {
  
  if (k==23 && z==59) {
  ObjectDelete("2");
  ObjectDelete("2");
  ObjectDelete("2");
   }
  */
 


     if (k==0 && z==0 && Day_max_min==true ) 
     {
        if (Close[iHighest(NULL,0,MODE_CLOSE,b,i)]> Open[iHighest(NULL,0,MODE_OPEN,b,i)])
        {
         ExtMapBuffer1[i] = Close[iHighest(NULL,0,MODE_CLOSE,b,i)];
         Name = " "+TimeToStr(Time[i]);
         Label = " "+TimeToStr(Time[i]);
         Price=StringConcatenate("Max", ExtMapBuffer1[i]);
         ObjectCreate(Name,OBJ_TREND,0,Time[iHighest(NULL,0,MODE_CLOSE,b,i)],ExtMapBuffer1[i],Time[i]+l,ExtMapBuffer1[i]);
         ObjectSet(Name, OBJPROP_COLOR, Green);
         ObjectSet(Name,OBJPROP_RAY,false);
          ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
          ObjectSet(Name, OBJPROP_WIDTH, 2);
          ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l,ExtMapBuffer1[i]);
          ObjectSetText(Label,Price , 8, "Arial", Red);
          ObjectSet(Label, OBJPROP_TIMEFRAMES, OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
   
    
    }
        
        else if (Close[iHighest(NULL,0,MODE_CLOSE,b,i)]<= Open[iHighest(NULL,0,MODE_OPEN,b,i)])
        {ExtMapBuffer1[i] = Open[iHighest(NULL,0,MODE_OPEN,b,i)];
      
        Name = " "+TimeToStr(Time[i]);
        Label = " "+TimeToStr(Time[i]);
        Price=StringConcatenate("Max ", ExtMapBuffer1[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iHighest(NULL,0,MODE_OPEN,b,i)],ExtMapBuffer1[i],Time[i]+l,ExtMapBuffer1[i]);
    ObjectSet(Name, OBJPROP_COLOR, Green);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l,ExtMapBuffer1[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
     ObjectSet(Label, OBJPROP_TIMEFRAMES, OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
   
    }
     
     
     
     
        
        
     //-----------------------------------------------------------------------------     
      if (Close[iLowest(NULL,0,MODE_CLOSE,b,i)]<= Open[iLowest(NULL,0,MODE_OPEN,b,i)])
        { ExtMapBuffer2[i]= Close[iLowest(NULL,0,MODE_CLOSE,b,i)];
    
        Name = Name+"";
        Label = "2 "+TimeToStr(Time[i]);
        Price=StringConcatenate("Min ", ExtMapBuffer2[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iLowest(NULL,0,MODE_CLOSE,b,i)],ExtMapBuffer2[i],Time[i]+l,ExtMapBuffer2[i]);
    ObjectSet(Name, OBJPROP_COLOR, Blue);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l,ExtMapBuffer2[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
    ObjectSet(Label, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
        
        
      }
      
      
      
      
        else  if (Close[iLowest(NULL,0,MODE_CLOSE,b,i)]> Open[iLowest(NULL,0,MODE_OPEN,b,i)])
      {ExtMapBuffer2[i]=Open[iLowest(NULL,0,MODE_OPEN,b,i)];
      
      Name = Name+"";
      Label = "2 "+TimeToStr(Time[i]);
        Price=StringConcatenate("Min ", ExtMapBuffer2[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iLowest(NULL,0,MODE_OPEN,b,i)],ExtMapBuffer2[i],Time[i]+l,ExtMapBuffer2[i]);
    ObjectSet(Name, OBJPROP_COLOR, Blue);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
     ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l,ExtMapBuffer2[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
    ObjectSet(Label, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    
    }  
      
    if (Close[iHighest(NULL,0,MODE_CLOSE,b,i)]> Open[iHighest(NULL,0,MODE_OPEN,b,i)] && 
    (Close[iLowest(NULL,0,MODE_CLOSE,b,i)]<= Open[iLowest(NULL,0,MODE_OPEN,b,i)]) ){
    ExtMapBuffer3[i]=Close[iHighest(NULL,0,MODE_CLOSE,b,i)]-((Close[iHighest(NULL,0,MODE_CLOSE,b,i)]-Close[iLowest(NULL,0,MODE_CLOSE,b,i)])/2);
    
    Price=StringConcatenate("Middle ", ExtMapBuffer3[i]);
    Midle = "3 "+TimeToStr(Time[i]);
    
    ObjectCreate(Midle,OBJ_TREND,0,Time[i],ExtMapBuffer3[i],Time[i]+l,ExtMapBuffer3[i]);
    ObjectSet(Midle,OBJPROP_RAY,false);
    ObjectSet(Midle,OBJPROP_STYLE,STYLE_DOT);
    ObjectSet(Midle, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    } 
    
    if(Close[iHighest(NULL,0,MODE_CLOSE,b,i)]> Open[iHighest(NULL,0,MODE_OPEN,b,i)] && 
    Close[iLowest(NULL,0,MODE_CLOSE,b,i)]> Open[iLowest(NULL,0,MODE_OPEN,b,i)]){
    ExtMapBuffer3[i]=Close[iHighest(NULL,0,MODE_CLOSE,b,i)]-((Close[iHighest(NULL,0,MODE_CLOSE,b,i)]-Open[iLowest(NULL,0,MODE_OPEN,b,i)])/2);
    Price=StringConcatenate("Middle ", ExtMapBuffer3[i]);
    Midle = "3 "+TimeToStr(Time[i]);
    
    ObjectCreate(Midle,OBJ_TREND,0,Time[i],ExtMapBuffer3[i],Time[i]+l,ExtMapBuffer3[i]);
    ObjectSet(Midle,OBJPROP_RAY,false);
    ObjectSet(Midle,OBJPROP_STYLE,STYLE_DOT);
    ObjectSet(Midle, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    }
    
    if (Close[iHighest(NULL,0,MODE_CLOSE,b,i)]<= Open[iHighest(NULL,0,MODE_OPEN,b,i)] &&
    ( Close[iLowest(NULL,0,MODE_CLOSE,b,i)]<= Open[iLowest(NULL,0,MODE_OPEN,b,i)]) ){
    ExtMapBuffer3[i]= Open[iHighest(NULL,0,MODE_OPEN,b,i)]- ((Open[iHighest(NULL,0,MODE_OPEN,b,i)]-Close[iLowest(NULL,0,MODE_CLOSE,b,i)])/2);
    Price=StringConcatenate("Middle ", ExtMapBuffer3[i]);
    Midle = "3 "+TimeToStr(Time[i]);
    
    ObjectCreate(Midle,OBJ_TREND,0,Time[i],ExtMapBuffer3[i],Time[i]+l,ExtMapBuffer3[i]);
    ObjectSet(Midle,OBJPROP_RAY,false);
    ObjectSet(Midle,OBJPROP_STYLE,STYLE_DOT);
    ObjectSet(Midle, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    }
     
    if (Close[iHighest(NULL,0,MODE_CLOSE,b,i)]<= Open[iHighest(NULL,0,MODE_OPEN,b,i)] &&
    Close[iLowest(NULL,0,MODE_CLOSE,b,i)]> Open[iLowest(NULL,0,MODE_OPEN,b,i)]) {
    ExtMapBuffer3[i]= Open[iHighest(NULL,0,MODE_OPEN,b,i)]- ((Open[iHighest(NULL,0,MODE_OPEN,b,i)]-Open[iLowest(NULL,0,MODE_OPEN,b,i)])/2);
    Price=StringConcatenate("Middle ", ExtMapBuffer3[i]);
    Midle = "3 "+TimeToStr(Time[i]);
    
    ObjectCreate(Midle,OBJ_TREND,0,Time[i],ExtMapBuffer3[i],Time[i]+l,ExtMapBuffer3[i]);
    ObjectSet(Midle,OBJPROP_RAY,false);
    ObjectSet(Midle,OBJPROP_STYLE,STYLE_DOT);
    ObjectSet(Midle, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    } 
 
 
 //---------------------------
 
 Name ="";
   ObjectCreate(Name,OBJ_RECTANGLE,0,Time[i],ExtMapBuffer1[i]*2,Time[i]+(oc_c*60*p_t*t),ExtMapBuffer2[i]/2);
   ObjectSet(Name, OBJPROP_COLOR, LemonChiffon);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5); 
   
   Name ="";
   ObjectCreate(Name,OBJ_RECTANGLE,0,Time[i]+(as*60*p_t*t),ExtMapBuffer1[i]*2,Time[i]+(as_c*60*p_t*t),ExtMapBuffer2[i]/2);
   ObjectSet(Name, OBJPROP_COLOR, PaleTurquoise);
   ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    
   
   Name ="";
   ObjectCreate(Name,OBJ_RECTANGLE,0,Time[i]+(eu*60*p_t*t),ExtMapBuffer1[i]*2,Time[i]+(eu_c*60*p_t*t),ExtMapBuffer2[i]/2);
   ObjectSet(Name, OBJPROP_COLOR, MistyRose);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5); 
    
   Name ="";
   ObjectCreate(Name,OBJ_RECTANGLE,0,Time[i]+(us*60*p_t*t),ExtMapBuffer1[i]*2,Time[i]+(us_c*60*p_t*t),ExtMapBuffer2[i]/2);
   ObjectSet(Name, OBJPROP_COLOR, PaleGreen);
   ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    
   
   Name ="2";
   ObjectCreate(Name,OBJ_RECTANGLE,0,Time[i]+(oc*60*p_t*t),ExtMapBuffer1[i]*2,Time[i]+(24*60*p_t*t),ExtMapBuffer2[i]/2);
   ObjectSet(Name, OBJPROP_COLOR, LemonChiffon);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5); 
 
 }
 
 
 
     if (k==0 && z==0 && TimeDayOfWeek(Time[i])==1) 
     {
 if (Close[iHighest(NULL,0,MODE_CLOSE,w,i)]> Open[iHighest(NULL,0,MODE_OPEN,w,i)])
        {
        ExtMapBuffer4[i] = Close[iHighest(NULL,0,MODE_CLOSE,w,i)];
        Name = "1"+TimeToStr(Time[i]);
        Label = "1"+TimeToStr(Time[i]);
        Price=StringConcatenate("Max Week", ExtMapBuffer4[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iHighest(NULL,0,MODE_CLOSE,w,i)],ExtMapBuffer4[i],Time[i]+l*5,ExtMapBuffer4[i]);
    ObjectSet(Name, OBJPROP_COLOR, Navy);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l*5,ExtMapBuffer4[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
     ObjectSet(Label, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
   
    
    }
        
        else if (Close[iHighest(NULL,0,MODE_CLOSE,w,i)]<= Open[iHighest(NULL,0,MODE_OPEN,w,i)])
        {ExtMapBuffer4[i] = Open[iHighest(NULL,0,MODE_OPEN,w,i)];
      
        Name = "1"+TimeToStr(Time[i]);
        Label = "1"+TimeToStr(Time[i]);
        Price=StringConcatenate("Max Week", ExtMapBuffer4[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iHighest(NULL,0,MODE_OPEN,w,i)],ExtMapBuffer4[i],Time[i]+l*5,ExtMapBuffer4[i]);
    ObjectSet(Name, OBJPROP_COLOR, Navy);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l*5,ExtMapBuffer4[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
     ObjectSet(Label, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
   
    }
 
 if (Close[iLowest(NULL,0,MODE_CLOSE,w,i)]<= Open[iLowest(NULL,0,MODE_OPEN,w,i)])
        { ExtMapBuffer5[i]= Close[iLowest(NULL,0,MODE_CLOSE,w,i)];
    
        Name = Name+"";
        Label = "22"+TimeToStr(Time[i]);
        Price=StringConcatenate("Min Week", ExtMapBuffer5[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iLowest(NULL,0,MODE_CLOSE,w,i)],ExtMapBuffer5[i],Time[i]+l*5,ExtMapBuffer5[i]);
    ObjectSet(Name, OBJPROP_COLOR, FireBrick);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l*5,ExtMapBuffer5[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
    ObjectSet(Label, OBJPROP_TIMEFRAMES, OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
        
        
      }
      
      
      
      
        else  if (Close[iLowest(NULL,0,MODE_CLOSE,w,i)]> Open[iLowest(NULL,0,MODE_OPEN,w,i)])
      {ExtMapBuffer5[i]=Open[iLowest(NULL,0,MODE_OPEN,w,i)];
      
      Name = Name+"";
      Label = "22"+TimeToStr(Time[i]);
        Price=StringConcatenate("MinWeek ", ExtMapBuffer5[i]);
    ObjectCreate(Name,OBJ_TREND,0,Time[iLowest(NULL,0,MODE_OPEN,w,i)],ExtMapBuffer5[i],Time[i]+l*5,ExtMapBuffer5[i]);
    ObjectSet(Name, OBJPROP_COLOR, FireBrick);
    ObjectSet(Name,OBJPROP_RAY,false);
    ObjectSet(Name, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 |  OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
     ObjectSet(Name, OBJPROP_WIDTH, 2);
    ObjectCreate(Label,OBJ_TEXT,0,Time[i]+0.8*l*5,ExtMapBuffer5[i]);
    ObjectSetText(Label,Price , 8, "Arial", Red);
    ObjectSet(Label, OBJPROP_TIMEFRAMES,OBJ_PERIOD_H4 | OBJ_PERIOD_H1 | OBJ_PERIOD_M30| OBJ_PERIOD_M15 | OBJ_PERIOD_M5);
    
    }  
 
  }
      
      

}  //   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+